SystemOrganization addCategory: #'DuinoBot-Etoys'!

ArduinoMorph subclass: #DuinoBotMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DuinoBot-Etoys'!

DuinoBotMorph class
	instanceVariableNames: 'robotForm'!

DuinoBotMorph class
	instanceVariableNames: 'robotForm'!

!DuinoBotMorph class methodsFor: 'viewer categories' stamp: 'Richo 11/23/2012 13:36'!
additionsToViewerCategories
^ #(
(#'duinobot - connection' (
#(slot duinoBotMode 'Let''s you change programming mode. Options are:

* Direct: The script will be executed in the computer and the orders will be transferred to the board via a serial port. Requires a serial connection with the board in order to run.

* Compiled: The script will be compiled and run inside the board. No communication with the computer is used afterwards.' DuinoBotMode readWrite Player getDuinoBotMode Player setDuinoBotMode:) "Only available if DuinoBot-EtoysCompiler is loaded"
#(command connect 'Connects this device' )
#(command disconnect 'Disconnects this device' )
#(slot isConnected 'Shows if the device is connected' Boolean readOnly Player getIsConnected Player unused )
#(slot portName 'Name of the OS port in which the device is connected' PEPort readWrite Player getPortName Player setPortName: )
#(slot duinoBotType 'The DuinoBot type that is being used. Make sure to set this right, otherwise the compilation will fail.' DuinoBotType readWrite Player getDuinoBotType Player setDuinoBotType: )
))

(#'duinobot - digital pins mode' (

#(slot #'digitalPin 2Mode' 'Indicates if the pin is in output/input mode' ArduinoPinMode readWrite Player getDigitalPin2Mode Player setDigitalPin2Mode:  )
#(slot #'digitalPin 3Mode' 'Indicates if the pin is in output/input mode' ArduinoPinMode readWrite Player getDigitalPin3Mode Player setDigitalPin3Mode:  )
#(slot #'digitalPin 4Mode' 'Indicates if the pin is in output/input mode' ArduinoPinMode readWrite Player getDigitalPin4Mode Player setDigitalPin4Mode:  )
#(slot #'digitalPin 5Mode' 'Indicates if the pin is in output/input mode' ArduinoPinMode readWrite Player getDigitalPin5Mode Player setDigitalPin5Mode:  )
#(slot #'digitalPin 6Mode' 'Indicates if the pin is in output/input mode' ArduinoPinMode readWrite Player getDigitalPin6Mode Player setDigitalPin6Mode:  )
#(slot #'digitalPin 7Mode' 'Indicates if the pin is in output/input mode' ArduinoPinMode readWrite Player getDigitalPin7Mode Player setDigitalPin7Mode:  )
#(slot #'digitalPin 8Mode' 'Indicates if the pin is in output/input mode' ArduinoPinMode readWrite Player getDigitalPin8Mode Player setDigitalPin8Mode:  )
#(slot #'digitalPin 9Mode' 'Indicates if the pin is in output/input mode' ArduinoPinMode readWrite Player getDigitalPin9Mode Player setDigitalPin9Mode:  )
#(slot #'digitalPin 10Mode' 'Indicates if the pin is in output/input mode' ArduinoPinMode readWrite Player getDigitalPin10Mode Player setDigitalPin10Mode:  )
#(slot #'digitalPin 11Mode' 'Indicates if the pin is in output/input mode' ArduinoPinMode readWrite Player getDigitalPin11Mode Player setDigitalPin11Mode:  )
#(slot #'digitalPin 12Mode' 'Indicates if the pin is in output/input mode' ArduinoPinMode readWrite Player getDigitalPin12Mode Player setDigitalPin12Mode:  )
#(slot #'digitalPin 13Mode' 'Indicates if the pin is in output/input mode' ArduinoPinMode readWrite Player getDigitalPin13Mode Player setDigitalPin13Mode:  )
))

(#'duinobot - digital pins' (
#(slot #'digitalPin 10' 'Accesses the current digital value of the pin' Boolean readWrite Player getDigitalPin10 Player setDigitalPin10: )
#(slot #'digitalPin 11' 'Accesses the current digital value of the pin' Boolean readWrite Player getDigitalPin11 Player setDigitalPin11: )
#(slot #'digitalPin 12' 'Accesses the current digital value of the pin' Boolean readWrite Player getDigitalPin12 Player setDigitalPin12: )
#(slot #'digitalPin 13' 'Accesses the current digital value of the pin' Boolean readWrite Player getDigitalPin13 Player setDigitalPin13: )
#(slot #'digitalPin 2' 'Accesses the current digital value of the pin' Boolean readWrite Player getDigitalPin2 Player setDigitalPin2: )
#(slot #'digitalPin 3' 'Accesses the current digital value of the pin' Boolean readWrite Player getDigitalPin3 Player setDigitalPin3: )
#(slot #'digitalPin 4' 'Accesses the current digital value of the pin' Boolean readWrite Player getDigitalPin4 Player setDigitalPin4: )
#(slot #'digitalPin 5' 'Accesses the current digital value of the pin' Boolean readWrite Player getDigitalPin5 Player setDigitalPin5: )
#(slot #'digitalPin 6' 'Accesses the current digital value of the pin' Boolean readWrite Player getDigitalPin6 Player setDigitalPin6: )
#(slot #'digitalPin 7' 'Accesses the current digital value of the pin' Boolean readWrite Player getDigitalPin7 Player setDigitalPin7: )
#(slot #'digitalPin 8' 'Accesses the current digital value of the pin' Boolean readWrite Player getDigitalPin8 Player setDigitalPin8: )
#(slot #'digitalPin 9' 'Accesses the current digital value of the pin' Boolean readWrite Player getDigitalPin9 Player setDigitalPin9: )
))

(#'duinobot - analog pins' (
#(slot #'isAnalogPin 0Active' 'Indicates if the analog pin is active' Boolean readWrite Player getIsAnalogPin0Active Player setIsAnalogPin0Active: )
#(slot #'isAnalogPin 1Active' 'Indicates if the analog pin is active' Boolean readWrite Player getIsAnalogPin1Active Player setIsAnalogPin1Active: )
#(slot #'isAnalogPin 2Active' 'Indicates if the analog pin is active' Boolean readWrite Player getIsAnalogPin2Active Player setIsAnalogPin2Active: )
#(slot #'isAnalogPin 3Active' 'Indicates if the analog pin is active' Boolean readWrite Player getIsAnalogPin3Active Player setIsAnalogPin3Active: )
#(slot #'isAnalogPin 4Active' 'Indicates if the analog pin is active' Boolean readWrite Player getIsAnalogPin4Active Player setIsAnalogPin4Active: )
#(slot #'isAnalogPin 5Active' 'Indicates if the analog pin is active' Boolean readWrite Player getIsAnalogPin5Active Player setIsAnalogPin5Active: )

#(slot #'analogPin 0' 'Shows the raw value of the analog pin' Number readOnly Player getAnalogPin0 Player unused )
#(slot #'analogPin 1' 'Shows the raw value of the analog pin' Number readOnly Player getAnalogPin1 Player unused )
#(slot #'analogPin 2' 'Shows the raw value of the analog pin' Number readOnly Player getAnalogPin2 Player unused )
#(slot #'analogPin 3' 'Shows the raw value of the analog pin' Number readOnly Player getAnalogPin3 Player unused )
#(slot #'analogPin 4' 'Shows the raw value of the analog pin' Number readOnly Player getAnalogPin4 Player unused )
#(slot #'analogPin 5' 'Shows the raw value of the analog pin' Number readOnly Player getAnalogPin5 Player unused )
))

(#'duinobot - motors' (
#(slot #'motor 0' 'Let''s you change the speed of the motor' Number readWrite Player getMotor0 Player setMotor0:)
#(slot #'motor 1' 'Let''s you change the speed of the motor' Number readWrite Player getMotor1 Player setMotor1:)
))


)! !

!DuinoBotMorph class methodsFor: 'parts bin' stamp: 'Richo 4/16/2012 16:29'!
descriptionForPartsBin
	"Answer a description for use in parts bins"
	^ self
		partName: 'DuinoBot' translatedNoop
		categories: ((PEUtilities isPEProject: Project current)
								ifTrue: [{'Physical Etoys' translatedNoop}]
								ifFalse: [#()])
		documentation: 'An object that lets you communicate with an DuinoBot board' translatedNoop! !

!DuinoBotMorph class methodsFor: 'initialize' stamp: 'Richo 11/27/2012 13:04'!
initialize
	"
	self initialize
	"
	lastBoardType := lastPortName := nil.
	'direct' translatedNoop.
	'compiled' translatedNoop.
	Vocabulary addStandardVocabulary: (SymbolListType new vocabularyName: #DuinoBotMode;
			 symbols: #(direct compiled )).
	Vocabulary addStandardVocabulary: (SymbolListType new vocabularyName: #DuinoBotType;
			 symbols: DuinoBotType allFriendlyNames asSortedCollection).! !

!DuinoBotMorph class methodsFor: 'form' stamp: 'Richo 8/31/2011 13:47'!
initializeForm
"
	form := nil.
"
^ form := PEUtilities formFromEncodedPNG: 'iVBORw0KGgoAAAANSUhEUgAAAY8AAAFYCAYAAACroXBwAAAABHNCSVQFBQUBSsjp7wAAK+hJ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'! !

!DuinoBotMorph class methodsFor: 'form' stamp: 'Richo 8/31/2011 14:59'!
robotForm
"
	robotForm := nil.
"
	^ robotForm ifNil: [robotForm :=  PEUtilities formFromEncodedPNG: 'iVBORw0KGgoAAAANSUhEUgAAAHoAAACWCAYAAAAR35wdAAAACXBIWXMAAA3XAAAN1wFCKJt4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']! !

!DuinoBotMorph class methodsFor: 'accessing' stamp: 'Richo 11/23/2012 15:09'!
typeClass
	^ DuinoBotType! !

!DuinoBotMorph methodsFor: 'drawing' stamp: 'Richo 8/31/2011 14:59'!
drawOn: aCanvas
	super drawOn: aCanvas.
	aCanvas translucentImage: self class robotForm at: self bounds topLeft + (22@17)! !

!DuinoBotMorph methodsFor: 'initialize' stamp: 'Richo 11/23/2012 14:46'!
initialize
	super initialize.
	self extent: self class form extent.
	arduino := DuinoBot new.
	boardType := self class lastBoardType.
	self initializePortName;
		initializePins;
		initializeSpecialPins! !

!DuinoBotMorph methodsFor: 'initialize' stamp: 'Richo 9/2/2011 15:47'!
initializePins
	| pos |
	pos := -27@93.
	6
		timesRepeat: [self
				addMorph: (ArduinoPinMorph justASketch center: self center + pos).
			pos := pos x + 13 @ pos y].
	pos :=  65@93.
	0
		to: 5
		do: [:i | 
			self
				addMorph: ((ArduinoAnalogPinMorph
						on: (arduino analogPin: i))
						center: self center + pos;
						setBalloonText: ('Analog pin {1}' translated format: {i})).
			pos := pos x + 13 @ pos y].
	pos := -79 @ -156.
	2
		timesRepeat: [self
				addMorph: (ArduinoPinMorph justASketch center: self center + pos).
			pos := pos x + 13 @ pos y].
	pos := -53@-156.
	13
		to: 8
		by: -1
		do: [:i | 
			self
				addMorph: ((ArduinoDigitalPinMorph
						on: (arduino digitalPin: i))
						center: self center + pos;
						setBalloonText: ('Digital pin {1}' translated format: {i})).
			pos := pos x + 13 @ pos y].
	pos := 39@-156.
	7
		to: 2
		by: -1
		do: [:i | 
			self
				addMorph: ((ArduinoDigitalPinMorph
						on: (arduino digitalPin: i))
						center: self center + pos;
						setBalloonText: ('Digital pin {1}' translated format: {i})).
			pos := pos x + 13 @ pos y].
	pos := 117@-156.
	1
		to: 0
		by: -1
		do: [:i | 
			self
				addMorph: (ArduinoPinMorph justASketch center: self center + pos).
			pos := pos x + 13 @ pos y]! !

!DuinoBotMorph methodsFor: 'initialize' stamp: 'Richo 8/31/2011 17:10'!
initializeSpecialPins
	"Sensors"
	 {164@293. 197@293. 230@293. 263@293. 296@293. 329@293}
		doWithIndex: [:distToOrigin :index | | x morph |
			self addMorph: ((DuinoBotSensorPinMorph on: (arduino analogPin: index - 1))
						position: self position + distToOrigin)].
	"Motors"
	{354@227.  354@192}
		doWithIndex: [:distToOrigin :index | | x morph |
			self addMorph: ((DuinoBotMotorPinMorph on: (arduino motorPin: index - 1))
						position: self position + distToOrigin)
		].! !

!DuinoBotMorph methodsFor: 'installing firmware' stamp: 'pe 2.0 12/2/2012 15:50'!
installFirmwareIfPossible
"If the DuinoBot-Compiler package is found in the image it will try to install DuinoBotFirmware and it will show a progress bar while doing so"
	Smalltalk 
		at: #DuinoBotUploader
		ifAbsent: [^self inform: 'The DuinoBot firmware does not seem to be installed.' translated].
	(self confirm: 'The DuinoBot firmware does not seem to be installed.
Do you want to install it now?' translated)
		ifFalse: [^ self].
	self disconnect.
	[PEUtilities
		showProgressBarWithLabel: 'Installing DuinoBot firmware' translated
		subLabel: '(this might take a few seconds)' translated
		forSeconds: 60
		while: [(Smalltalk at: #DuinoBotDirectModeSketch)
							translatedToArduinoC
						uploadOnPort: portName
						arduinoType: (self typeClass withFriendlyName: boardType)]]
		on: (Smalltalk at: #CompilingSketchError)
		do: [^ self inform: 'Installing DuinoBot firmware failed for unknown reasons.
Make sure you selected the correct board type.
IMPORTANT: Unplug and replug your arduino before proceeding' translated].
	self connect;
		inform: 'The arduino firmware was successfully installed.' translated! !

!DuinoBotMorph methodsFor: 'motors' stamp: 'Richo 8/31/2011 17:05'!
m0
	^ (arduino motorPin: 0) value! !

!DuinoBotMorph methodsFor: 'motors' stamp: 'Richo 8/31/2011 17:05'!
m0: speed
	(arduino motorPin: 0) value: speed! !

!DuinoBotMorph methodsFor: 'motors' stamp: 'Richo 8/31/2011 17:05'!
m1
	^ (arduino motorPin: 1) value! !

!DuinoBotMorph methodsFor: 'motors' stamp: 'Richo 8/31/2011 17:05'!
m1: speed
	(arduino motorPin: 1) value: speed! !

!DuinoBotMorph methodsFor: 'initialize' stamp: 'Richo 8/31/2011 13:41'!
newPlayerInstance
	^DuinoBotPlayer newUserInstance ! !

!DuinoBotMorph methodsFor: 'accessing' stamp: 'Richo 11/23/2012 15:01'!
portName
	^ self arduinoType isHID
		ifTrue: [#hid]
		ifFalse: [super portName]! !

ArduinoPlayer subclass: #DuinoBotPlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DuinoBot-Etoys'!

!DuinoBotPlayer class methodsFor: 'as yet unclassified' stamp: 'Richo 4/10/2012 16:07'!
officialClass
	^ DuinoBotPlayer! !

!DuinoBotPlayer methodsFor: 'slots' stamp: 'Richo 11/23/2012 13:37'!
getDuinoBotType
^ self costume renderedMorph boardType! !

!DuinoBotPlayer methodsFor: 'motors' stamp: 'Richo 8/31/2011 13:37'!
getMotor0
	^ self costume renderedMorph m0! !

!DuinoBotPlayer methodsFor: 'motors' stamp: 'Richo 8/31/2011 13:37'!
getMotor1
	^ self costume renderedMorph m1! !

!DuinoBotPlayer methodsFor: 'slots' stamp: 'Richo 11/23/2012 13:37'!
setDuinoBotType: aSymbol
^ self costume renderedMorph boardType: aSymbol! !

!DuinoBotPlayer methodsFor: 'motors' stamp: 'Richo 8/31/2011 13:37'!
setMotor0: aNumber
	self costume renderedMorph m0: aNumber! !

!DuinoBotPlayer methodsFor: 'motors' stamp: 'Richo 8/31/2011 13:37'!
setMotor1: aNumber
	self costume renderedMorph m1: aNumber! !

ArduinoAnalogPinMorph subclass: #DuinoBotSensorPinMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DuinoBot-Etoys'!

!DuinoBotSensorPinMorph methodsFor: 'initialization' stamp: 'Richo 8/31/2011 16:21'!
attachNewDevice
	| newDevice |
	newDevice := self newDevice.
	newDevice isNil ifTrue: [self borderColor: Color transparent.^self].
	newDevice center: self center.
	newDevice openInWorld.
	self attach: newDevice! !

!DuinoBotSensorPinMorph methodsFor: 'drawing' stamp: 'Richo 8/31/2011 16:13'!
drawOn: aCanvas
	aCanvas fillRectangle: self bounds fillStyle: self fillStyle borderStyle: self borderStyle.
! !

!DuinoBotSensorPinMorph methodsFor: 'initialization' stamp: 'Richo 8/31/2011 17:15'!
initialize
	super initialize.
	self extent: 33@44;
		color: Color transparent;
		borderWidth: 2;
		borderColor: Color transparent.
	attachmentPoint center: self center! !

!DuinoBotSensorPinMorph methodsFor: 'event handling' stamp: 'Richo 8/31/2011 16:21'!
mouseEnter: evt forMorph: aMorph 
	self borderColor: Color red! !

!DuinoBotSensorPinMorph methodsFor: 'event handling' stamp: 'Richo 8/31/2011 16:20'!
mouseLeave: evt forMorph: aMorph 
	self borderColor: Color transparent! !

AttachableDeviceMorph subclass: #RGMotorMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DuinoBot-Etoys'!

!RGMotorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 3/6/2012 10:01'!
additionsToViewerCategories
^ #(
(#motor (
#(slot speed 'You can change the speed of the motor' Number readWrite Player getSpeed Player setSpeed: )

)))! !

!RGMotorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 8/31/2011 17:01'!
device
	^ RGMotor! !

!RGMotorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 8/31/2011 16:48'!
initializeForm
"
	form := nil.
"
^form := PEUtilities formFromEncodedPNG:  'iVBORw0KGgoAAAANSUhEUgAAAI0AAAB6CAYAAACCydAEAAAABHNCSVQFBQUBSsjp7wAAAppJ
REFUeF7l3a2Og0AARlFk5T4yj4BEIpFIJLISySNUVq6bzRrCsmkK24WZ6bnJJydpk5MS0r8i
l9q2DamsKC4/tv2cn4/GR+Oj8dH4aHw0Phofjd+LaPq+D8MwRNkazfZzftHQxATjo/HR+GgE
NF3XRQXjo8kQTexXGR+Nj8ZH46Px0fj5aPx8NH4+Gh+Nj8ZH46Px0fhofDR+Pho/H83zTdM0
736/Z7XlY/fRnIjmEaAcNo7jPB/NiWiappkX+zns3XUxH42PxkeTMpqqqual9PHV/R939dH4
d0/+3ZOPxs9H4+ej8fPR+Gh8ND4aH42Pxkfjo/Hz0fj5aHw0PhofjY/GR4Oi8b/L7eej8Tse
jf9TI34+Gr9z0CwvVTG2RrP9nF90NP4PNfr5aPx8ND4aH42Pxkfjo/HR+Gj8fDR+PhofjY/G
R+Oj8dH4aHw0fj4aPx+Nn4/GR+Oj8dH4aHw0PhofjZ+Pxs9H46Px0fhofDQ+Gh+NjyafLuHs
+WgyrbsO4Xs+Gh/NLjA+Gh+Nj8ZHc0xlXwX/8uSj8dH4aHw0PhofjY/GR+Oj8dH4aHw0Phof
jY/GR+Oj8dH4aHw0PhofjY/GR+Oj8dH4aHw0PhofjY/GR+Oj8dH4aHw0PhofjY/GR+Oj8dH4
aHw0PhofjY/GR+Oj8dH4aHw0PhofjY/GR+Oj8dH4aHw0PhofjY/GR+Oj8dH4aHw0Fpqp/gjP
5qPx0fxC83krH85H46Px0fhofDQ+Gh+Nj8ZH46Px0fhofDQ+Gh+Nj8ZH46Px0fhofDQ+Gh+N
/96T/96Tj+a/8/+FxUfzEhwfjY/mD/lofDQZ5KNJo6zy0fj5aPyOryzLkMrWaLaf8/PR+Gh8
ND6aN6uu6pDK1mi2n3uPvgAOPmpRRKe/+QAAAABJRU5ErkJggg=='! !

!RGMotorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 8/31/2011 16:57'!
newConnector
	^ ArduinoWireMorph new
		 lineColor: Color black;
		borderColor: Color gray;
		lineWidth: 5;
		 yourself! !

!RGMotorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 8/31/2011 17:11'!
newConnectorFromMorph: m1 toMorph: m2
^ (ArduinoWireMorph fromMorph: m1 toMorph: m2)
		 lineColor: Color black;
		borderColor: Color gray;
		lineWidth: 5;
		 yourself! !

!RGMotorMorph methodsFor: 'as yet unclassified' stamp: 'Richo 8/31/2011 16:56'!
attachmentPointsSpecs
	^ {
		"{#center. #color. #borderColor}"
		{self center + (-65@45) . Color transparent. Color transparent}.

	}! !

!RGMotorMorph methodsFor: 'as yet unclassified' stamp: 'Richo 8/31/2011 16:57'!
mouseDownPin: attachmentPointIndex evt: evt morph: attachmentPoint 
	(self isAttachedAt: attachmentPointIndex)
		ifTrue: [^ self].
	self class newConnector startWiringFrom: attachmentPoint! !

!RGMotorMorph methodsFor: 'as yet unclassified' stamp: 'Richo 8/31/2011 17:22'!
speed
	^ [device speed] on: Error do: [-1]! !

!RGMotorMorph methodsFor: 'as yet unclassified' stamp: 'Richo 8/31/2011 17:23'!
speed: aNumber
	^ [device speed: aNumber] on: Error do: []! !

ArduinoPinMorph subclass: #DuinoBotMotorPinMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DuinoBot-Etoys'!

!DuinoBotMotorPinMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 8/31/2011 17:08'!
devices
	^ {RGMotorMorph}! !

!DuinoBotMotorPinMorph methodsFor: 'as yet unclassified' stamp: 'Richo 8/31/2011 17:12'!
attachNewDevice
	| newDevice |
	newDevice := self newDevice.
	newDevice isNil ifTrue: [self borderColor: Color transparent.^self].
	newDevice center: self center.
	newDevice openInWorld.
	self attach: newDevice! !

!DuinoBotMotorPinMorph methodsFor: 'as yet unclassified' stamp: 'Richo 8/31/2011 17:08'!
drawOn: aCanvas
	aCanvas fillRectangle: self bounds fillStyle: self fillStyle borderStyle: self borderStyle.
! !

!DuinoBotMotorPinMorph methodsFor: 'as yet unclassified' stamp: 'Richo 8/31/2011 17:14'!
initialize
	super initialize.
	self extent: 37@35;
		color: Color transparent;
		borderWidth: 2;
		borderColor: Color transparent.
	attachmentPoint center: self center! !

!DuinoBotMotorPinMorph methodsFor: 'as yet unclassified' stamp: 'Richo 9/2/2011 09:55'!
mouseEnter: evt forMorph: aMorph 
	self borderColor: Color red! !

!DuinoBotMotorPinMorph methodsFor: 'as yet unclassified' stamp: 'Richo 8/31/2011 17:09'!
mouseLeave: evt forMorph: aMorph 
	self borderColor: Color transparent! !

!DuinoBotMotorPinMorph methodsFor: 'as yet unclassified' stamp: 'Richo 4/13/2012 16:59'!
move: aDevice
	aDevice 
		bottom: self top - 50;
		left: self right + 50.
	self controlDeviceBounds: aDevice! !
DuinoBotMorph initialize!
